package cn.com.infosec.crypto.tls;

import cn.com.infosec.crypto.Digest;
import cn.com.infosec.crypto.digests.MD5Digest;
import cn.com.infosec.crypto.digests.SHA1Digest;

public class CombinedHash implements Digest {
   private Digest md5;
   private Digest sha1;

   public CombinedHash() {
      CombinedHash var10000 = this;
      CombinedHash var10001 = this;
      super();
      MD5Digest var1;
      var1 = new MD5Digest.<init>();
      var10001.md5 = var1;
      SHA1Digest var2;
      var2 = new SHA1Digest.<init>();
      var10000.sha1 = var2;
   }

   public String getAlgorithmName() {
      return this.md5.getAlgorithmName() + " and " + this.sha1.getAlgorithmName() + " for TLS 1.0";
   }

   public int getDigestSize() {
      return 36;
   }

   public void update(byte in) {
      this.md5.update(in);
      this.sha1.update(in);
   }

   public void update(byte[] in, int inOff, int len) {
      this.md5.update(in, inOff, len);
      this.sha1.update(in, inOff, len);
   }

   public int doFinal(byte[] out, int outOff) {
      return this.md5.doFinal(out, outOff) + this.sha1.doFinal(out, outOff + 16);
   }

   public void reset() {
      this.md5.reset();
      this.sha1.reset();
   }
}
